//SLAVE NANO 1
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_ST7735.h>
#include <SD.h>
#include <SPI.h>
#define SD_CS    4  // Chip select line for SD card
#define TFT_CS  10  // Chip select line for TFT display
#define TFT_DC   8  // Data/command line for TFT
#define TFT_RST  -1  // Reset line for TFT (or connect to +5V)

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST);
// D3 is Tone.

// this is a large buffer for replies
char replybuffer[255];
String initiator;
String dataString;
const char webAddress[100] = "http://www.goatindustries.co.uk/test/send.php?";
char url[120];

String nothing;
int numberId =0;
String resultForNumberId;
String numberA;
int stringLength =0;
String testad;
float result101=0.00;
float result102=0.00;
float result103=0.00;
float result104=0.00;
float result105=0.00;
float result106=0.00;
float result107=0.00;

int frequency;
int rain=0;
float knots;
float knotsMax;
float knotsAv;
float correction =0;
float calibration = 1.0047;    // (46.62 / 46.4)

int n=0;
int i=0;
String compileA;
char rabbits[10];
int a;
int k;
int z=0;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup() {
  Serial.begin(115200);
  // Initialize 1.8" TFT
  tft.initR(INITR_BLACKTAB);               // initialize a ST7735S chip, black tab
  Serial.println("OK!");
  tft.setRotation(3);                      // Rotate the TFT text 3 is 180 degrees.
  tft.fillScreen(ST7735_BLACK);
  tft.setTextSize(5);
  tft.setTextColor(ST7735_RED);
  delay(20);    
  tft.setCursor(30, 10);
  tft.print("CAT");
  delay(1000);
  tft.fillScreen(ST7735_BLACK);
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  Wire.begin(11);                // join i2c bus with address #11
  Wire.onReceive(receiveEvent); // register event
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
 // while (!Serial);                           // Use this for initiating program by opening of serial monitor. Delete in normal operation.


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   Serial.println("Waiting for data from i2c  ...........");  

}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void loop() 
  {
   printToScreen();
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   if(rain>0)
   {
   tone (3,1000+(rain*250),100);
   }
   else
   {
    tone (3,400,100);
   }
   if (result105==1)
   {
   tone (3,1000,100);    
   delay(200);
   tone (3,1000,100);
   }
   delay(5000);

   Serial.println("");
   Serial.print("Result 101:   ");Serial.println(result101,2);
   Serial.print("Result 102:   ");Serial.println(result102,2);
   Serial.print("Result 103:   ");Serial.println(result103,2);
   Serial.print("Result 104:   ");Serial.println(result104,2);
   Serial.print("Result 105:   ");Serial.println(result105,2);
   Serial.print("Result 106:   ");Serial.println(result106,2);
   Serial.print("Result 107:   ");Serial.println(result107,2);

   adjustments();
   knots = (frequency * calibration /10) + correction;                 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}
// End of main loop.
//////////////////////
void receiveEvent(int bytes)
{
  //delay(5000); // wait for data to be sent.
  a=20;
  while (a>0) // This looks for the correct numberId to iniate the next if command.
  {
  numberId = Wire.read(); 
//  Serial.print("Possible number Id:   ");Serial.println(numberId); 
  
  n=-1;
  compileA = nothing;
  testad = nothing;
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  
 //   Serial.println(""); 
    if (numberId==101)
    {
    unravelData();
    result101 = (rabbits+nothing).toInt()/100.00;
    }
    if (numberId==102)
    {
    unravelData();
    result102 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==103)
    {
    unravelData();
    result103 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==104)
    {
    unravelData();
    result104 = (rabbits+nothing).toInt()/100.00;    
    }
    if (numberId==105)
    {
    unravelData();
    result105 = (rabbits+nothing).toInt()/100.00;  
    }
    if (numberId==106)
    {
    unravelData();
    result106 = (rabbits+nothing).toInt()/100.00;  
    }    
    if (numberId==107)
    {
    unravelData();
    result107 = (rabbits+nothing).toInt()/100.00;  
    }    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
  a--; 
  delay(100);
  }
   delay(10); 
   z=1;                 // recieveEvent is on an interrupt so when it's triggered it changes z to 1 and allows main loop. 
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
void unravelData()
{
     a=10;
    stringLength = Wire.read(); 
      while (n<stringLength)
      {
      compileA = testad + compileA;
      testad = nothing + Wire.read(); // This is a string.
      n++;

  //    Serial.print("Compile:  ");Serial.println(compileA); 
      }
    
  numberA = compileA;
//  Serial.print("NumberA:  ");Serial.println(numberA); 
//  Serial.print("String length:   ");Serial.println(stringLength); 
  
 //Builds the rabbits character:
      i=stringLength;
      for (int aa=0;aa<=i;aa++)                                              
      {
          rabbits[aa] = compileA[aa];
      }  
 //Now create a string in which the last 3 characters represent the ID. The string can have the last four characters removed before being processed at the next stage.
      resultForNumberId = nothing + rabbits +" & " + numberId;
   
 //   Serial.print("rabbits:  ");Serial.println(rabbits);  
 //   Serial.print("Result for number Id: ");Serial.print(numberId); Serial.print(" is: "); Serial.println(resultForNumberId );
 //   Serial.println("");
}     

void printToScreen()
{
    rectangle2 ();
//    rectangle1 ();
   // tft.fillScreen(ST7735_BLACK);
    tft.setTextSize(2);
    tft.setTextColor(ST7735_BLUE);
    delay(10);    
    tft.setCursor(20, 10);
  //  tft.print("Windspeed");

    tft.setTextSize(2);
    tft.setCursor(0, 10);
    tft.setTextColor(ST7735_YELLOW);    
    tft.print("Vane:");
    tft.setCursor(80, 10);
    tft.print(result107);  
    //tft.print(millis()/1000);     

    rain = result106;
    tft.setTextSize(2);
    tft.setCursor(0, 30);
    tft.setTextColor(ST7735_YELLOW);    
    tft.print("Rain:");
    tft.setCursor(80, 30);
    tft.print(rain);     

    frequency = result101;
    tft.setTextSize(2);
    tft.setCursor(0, 50);
    tft.setTextColor(ST7735_YELLOW);    
    tft.print("Freq:");
    tft.setCursor(80, 50);
    tft.print(frequency); 

    knots = result102;
    tft.setCursor(0, 70);  
    tft.print("Knots:");
    tft.setCursor(80, 70);
    tft.print(knots); 

    knotsMax = result103;
    tft.setCursor(0, 90);  
    tft.print("Max:");
    tft.setCursor(80, 90);
    tft.print(knotsMax); 

    knotsAv = result104;
    tft.setCursor(0, 110);  
    tft.print("Av:");
    tft.setCursor(80, 110);
    tft.print(knotsAv); 
    
          
    Serial.print("Frequency = ");
    Serial.println(frequency,1);  
//    Serial.print("Knots. = ");
//    Serial.println(knots,2);   
//    Serial.print("Knots Dec = ");
//    Serial.println(knotsDecInt);          
//    Serial.print("Max. = ");
//    Serial.println(knotsMax,2);  
//    Serial.print("Av. = ");
//    Serial.println(knotsAvInt,1);  
//    Serial.print("char c is: ");   
//    Serial.println(c[10]);                          // print the character      
//    Serial.println("");             
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void rectangle1 ()
{
          tft.fillRect(10, 5, 125, 25, ST7735_RED);
          // x,y,(from top left corner)w,h
}
void rectangle2 ()
{
          tft.fillRect(75, 05, 80, 120, ST7735_RED);
          // x,y,(from top left corner)w,h
}
void adjustments()
{   
    if ((frequency >=1) && (frequency <=100)) {correction = 0.20;}
    if ((frequency >100) && (frequency <=200)) {correction = 0.10;}
    if ((frequency >200) && (frequency <=300)) {correction = -0.25;}
    if ((frequency >300) && (frequency <=400)) {correction = -0.60;}
    if ((frequency >400) && (frequency <=500)) {correction = -1;}
    if ((frequency >500) && (frequency <=600)) {correction = -1.4;}
    if ((frequency >600) && (frequency <=700)) {correction = -1.75;}
    if ((frequency >700) && (frequency <=800)) {correction = -2;}
    if ((frequency >800) && (frequency <=900)) {correction = -2.20;}
    if ((frequency >900) && (frequency <=1000)) {correction = -2.35;}
    if ((frequency >1000) && (frequency <=1100)) {correction = -2.40;}
    if ((frequency >1100) && (frequency <=1200)) {correction = -2.50;}
    if ((frequency >1200) && (frequency <=1300)) {correction = -2.50;}
    if ((frequency >1300) && (frequency <=1400)) {correction = -2.50;}
    if ((frequency >1400) && (frequency <=1500)) {correction = -2.45;}
    if ((frequency >1500) && (frequency <=1600)) {correction = -2.40;}  
}
